/********************************************************************************************************/
/**																									   **/
/**            Programme servant  l'exportation des tableaux SAs dans Excel                           **/
/** 		   Cre le : 																		 	   **/
/**  		   Modifier le : 4/08/09																   **/
/**            Marche  suivre : Vous devez changer, dans le "let", si ncessaire le chemin d'accs    **/
/**                              du fichier  exporter, et le nom du fichier  exporter en y           **/ 
/**                              inscrivant la dernire version. Le fichier  exporter est             **/
/**                              GraphiquesPrsents_?.xls.Ensuite excuter le programme au complet.   **/                            
/**																									   **/
/********************************************************************************************************/
dm log "color error orange reverse" continue; 

libname martin "\\fic1\DOC\DP_SAS\PlanTransformationParOptimisation\CLUBSAS";

*%let nom = \\fic1\doc\DP_SAS\PlanTransformationParOptimisation\PlanReel\GraphiquesPrsents_v22b3I_retraite.xls;
%let nom = \\fic1\DOC\DP_SAS\PlanTransformationParOptimisation\CLUBSAS\GraphiquesPrsents.xls;

/***********************************************************************************/
/******                 Tableaux  exporter en Excel (debut)                   *****/
/***********************************************************************************/

/** Nombre d'anne au plan avec la variable &anfin **/

proc sort data=martin.to_chart out=to_chart;
	by anfin;
run;

data _null_;
	set to_chart end=fin;
	by anfin;
	retain max 0 compteur 0;
	if first.anfin then compteur = 1;
		else compteur = compteur + 1;
	if compteur > max then max = compteur;
	if fin then call symput('anfin',compress(max));
run;

data test;
	anfin = &anfin;
run;

/*****  DistDSI , jp dsi par anne par pralable *****/ 
proc summary data=martin.tableau(where=(an<=max)) nway;
	class tri activite3 an;
	id prealable;
	var CoutRessInfo;
	output out = export_JP_DSI(drop = _type_ _freq_) sum=;
run;
  
proc transpose data=Export_JP_DSI out=Export_JP_DSI(drop=_name_)prefix=an;
	var CoutRessInfo;
	by tri activite3 prealable;
run;

data export_jp_dsi2;
	set export_jp_dsi;

	rename an1=an2008_2009
		   an2=an2009_2010
	       an3=an2010_2011
	       an4=an2011_2012
	       an5=an2012_2013
		   an6=an2013_2014
		   an7=an2014_2015
		   an8=an2015_2016
		   an9=an2016_2017
		   an10=an2017_2018
		   an11=an2018_2019
		   an12=an2019_2020
		   an13=an2020_2021
		   an14=an2021_2022
           an15=an2022_2023
		   an16=an2023_2024
		   an17=an2024_2025
		   an18=an2025_2026
		   an19=an2026_2027
		   an20=an2027_2028
 		   an21=an2028_2029
		   an22=an2029_2030
		   an23=an2030_2031
		   an24=an2031_2032
		   an25=an2032_2033
		   an26=an2033_2034	
		   an27=an2034_2035	
		   an28=an2035_2036	
		   an29=an2036_2037
		   an30=an2037_2038; 
	 
run;

PROC EXPORT DATA=export_jp_dsi2
			OUTFILE="&nom"
            DBMS=excel
			REPLACE;
            SHEET="TempDistDSI";			
RUN;

/*****  DistOp , jp par anne par pralable *****/ 
proc summary data=martin.tableau(where=(an<=max)) nway;
	class tri activite3 an;
	id prealable;
	var CoutRessOp;
	output out = export_JP_op(drop = _type_ _freq_) sum=;
run;

proc transpose data=Export_JP_op out=Export_JP_op(drop=_name_) prefix=an;
	var CoutRessOp;
	by tri activite3 prealable;
run;

data export_jp_op2;
	set export_jp_op;

	rename an1=an2008_2009
		   an2=an2009_2010
	       an3=an2010_2011
	       an4=an2011_2012
	       an5=an2012_2013
		   an6=an2013_2014
		   an7=an2014_2015
		   an8=an2015_2016
		   an9=an2016_2017
		   an10=an2017_2018
		   an11=an2018_2019
		   an12=an2019_2020
		   an13=an2020_2021
		   an14=an2021_2022
           an15=an2022_2023
		   an16=an2023_2024
		   an17=an2024_2025
		   an18=an2025_2026
		   an19=an2026_2027
		   an20=an2027_2028
 		   an21=an2028_2029
		   an22=an2029_2030
		   an23=an2030_2031
		   an24=an2031_2032
		   an25=an2032_2033
		   an26=an2033_2034	
		   an27=an2034_2035	
		   an28=an2035_2036	
		   an29=an2036_2037
		   an30=an2037_2038; 
run;

PROC EXPORT DATA=export_jp_op2
			OUTFILE="&nom"
            DBMS=excel
			REPLACE;
            SHEET="TempDistOP";			
RUN;

/*****  Distcouttotal , jp dsi par anne par pralable *****/ 

proc summary data=martin.tableau(where=(an<=max)) nway;
	class tri activite3 an;
	id prealable;
	var Couttotal;
	output out = export_JP_ct(drop = _type_ _freq_) sum=;
run;

proc transpose data=Export_JP_ct out=Export_JP_ct(drop=_name_) prefix=an;
	var Couttotal;
	by tri activite3 prealable;
run;

data export_jp_ct2;
	set export_jp_ct;

	rename an1=an2008_2009
		   an2=an2009_2010
	       an3=an2010_2011
	       an4=an2011_2012
	       an5=an2012_2013
		   an6=an2013_2014
		   an7=an2014_2015
		   an8=an2015_2016
		   an9=an2016_2017
		   an10=an2017_2018
		   an11=an2018_2019
		   an12=an2019_2020
		   an13=an2020_2021
		   an14=an2021_2022
           an15=an2022_2023
		   an16=an2023_2024
		   an17=an2024_2025
		   an18=an2025_2026
		   an19=an2026_2027
		   an20=an2027_2028
 		   an21=an2028_2029
		   an22=an2029_2030
		   an23=an2030_2031
		   an24=an2031_2032
		   an25=an2032_2033
		   an26=an2033_2034	
		   an27=an2034_2035	
		   an28=an2035_2036	
		   an29=an2036_2037
		   an30=an2037_2038; 
		   
run;

PROC EXPORT DATA=export_jp_ct2
			OUTFILE="&nom"
            DBMS=excel
			REPLACE;
            SHEET="TempDistTotal";
RUN;

/*****  CoutInfo, jp dsi par tri par anne *****/ 

proc summary data=martin.tableau;
	class tri an;
	var CoutRessInfo;
	output out = Export_CAT_JP_DSI(drop = _type_ _freq_) sum=;
run;

data export_CAT_JP_DSI;
	set export_CAT_JP_DSI;
	if an > &anfin then delete;
run;

PROC EXPORT DATA=export_CAT_JP_DSI
			OUTFILE="&nom"
            DBMS=excel
			REPLACE;
            SHEET="CoutInfo";
RUN;

/*****  CoutOp, jp op par tri par anne *****/ *** il faut valider avec le tableau 2 ***;
proc summary data=martin.tableau;
	class tri an;
	var CoutRessOp;
	output out = Export_CAT_JP_op(drop = _type_ _freq_) sum=;
run;

data export_CAT_jp_op;
	set export_CAT_JP_op;
	if an > &anfin then delete;
run;

PROC EXPORT DATA=export_CAT_JP_op
			OUTFILE="&nom"
            DBMS=excel
			REPLACE;
            SHEET="CoutOp";
RUN;

/*****  CoutTotal, cout par tri par anne *****/ 
proc summary data=martin.tableau;
	class tri an;
	var CoutTotal;
	output out = Export_CAT_Cout_Total(drop = _type_ _freq_) sum=;
run;

data Export_CAT_Cout_Total;
	set Export_CAT_Cout_Total;
	if an > &anfin then delete;
run;

PROC EXPORT DATA=Export_Cat_Cout_Total
			OUTFILE="&nom"
            DBMS=excel
			REPLACE;
            SHEET="CoutTotal";
RUN;

proc summary data=martin.tableau;
	class tri an;
	var CoutTotalop;
	output out = test(drop = _type_ _freq_) sum=;
run;

   
/*****  DistSPRR , jp SPRR par anne par pralable *****/ 
proc summary data=martin.tableau(where=(an<=max)) nway;
	class tri activite3 an;
	id prealable;
	var CoutRessSPRR;
	output out = export_JP_SPRR(drop = _type_ _freq_) sum=;
run;
  
proc transpose data=Export_JP_SPRR out=Export_JP_SPRR(drop=_name_)prefix=an;
	var CoutRessSPRR;
	by tri activite3 prealable;
run;

data export_jp_SPRR2(drop = _LABEL_);
	set export_jp_SPRR;

	rename an1=an2008_2009
		   an2=an2009_2010
	       an3=an2010_2011
	       an4=an2011_2012
	       an5=an2012_2013
		   an6=an2013_2014
		   an7=an2014_2015
		   an8=an2015_2016
		   an9=an2016_2017
		   an10=an2017_2018
		   an11=an2018_2019
		   an12=an2019_2020
		   an13=an2020_2021
		   an14=an2021_2022
           an15=an2022_2023
		   an16=an2023_2024
		   an17=an2024_2025
		   an18=an2025_2026
		   an19=an2026_2027
		   an20=an2027_2028
 		   an21=an2028_2029
		   an22=an2029_2030
		   an23=an2030_2031
		   an24=an2031_2032
		   an25=an2032_2033
		   an26=an2033_2034	
		   an27=an2034_2035	
		   an28=an2035_2036	
		   an29=an2036_2037
		   an30=an2037_2038; 
	 
run;

PROC EXPORT DATA=export_jp_SPRR2
			OUTFILE="&nom"
            DBMS=excel
			REPLACE;
            SHEET="TempDistSPRR";			
RUN;

/*****  DistSPPAF , jp SPPAF par anne par pralable *****/ 
proc summary data=martin.tableau(where=(an<=max)) nway;
	class tri activite3 an;
	id prealable;
	var CoutRessSPPAF;
	output out = export_JP_SPPAF(drop = _type_ _freq_) sum=;
run;
  
proc transpose data=Export_JP_SPPAF out=Export_JP_SPPAF(drop=_name_)prefix=an;
	var CoutRessSPPAF;
	by tri activite3 prealable;
run;

data export_jp_SPPAF2(drop = _LABEL_);
	set export_jp_SPPAF;

	rename an1=an2008_2009
		   an2=an2009_2010
	       an3=an2010_2011
	       an4=an2011_2012
	       an5=an2012_2013
		   an6=an2013_2014
		   an7=an2014_2015
		   an8=an2015_2016
		   an9=an2016_2017
		   an10=an2017_2018
		   an11=an2018_2019
		   an12=an2019_2020
		   an13=an2020_2021
		   an14=an2021_2022
           an15=an2022_2023
		   an16=an2023_2024
		   an17=an2024_2025
		   an18=an2025_2026
		   an19=an2026_2027
		   an20=an2027_2028
 		   an21=an2028_2029
		   an22=an2029_2030
		   an23=an2030_2031
		   an24=an2031_2032
		   an25=an2032_2033
		   an26=an2033_2034	
		   an27=an2034_2035	
		   an28=an2035_2036	
		   an29=an2036_2037
		   an30=an2037_2038; 
	 
run;

PROC EXPORT DATA=export_jp_SPPAF2
			OUTFILE="&nom"
            DBMS=excel
			REPLACE;
            SHEET="TempDistSPPAF";			
RUN;

/*****  Distautres , jp autres par anne par pralable *****/ 
proc summary data=martin.tableau(where=(an<=max)) nway;
	class tri activite3 an;
	id prealable;
	var CoutRessAutres;
	output out = export_JP_Autres(drop = _type_ _freq_) sum=;
run;
  
proc transpose data=Export_JP_Autres out=Export_JP_Autres(drop=_name_)prefix=an;
	var CoutRessAutres;
	by tri activite3 prealable;
run;

data export_jp_Autres2 (drop = _LABEL_);
	set export_jp_Autres;

	rename an1=an2008_2009
		   an2=an2009_2010
	       an3=an2010_2011
	       an4=an2011_2012
	       an5=an2012_2013
		   an6=an2013_2014
		   an7=an2014_2015
		   an8=an2015_2016
		   an9=an2016_2017
		   an10=an2017_2018
		   an11=an2018_2019
		   an12=an2019_2020
		   an13=an2020_2021
		   an14=an2021_2022
           an15=an2022_2023
		   an16=an2023_2024
		   an17=an2024_2025
		   an18=an2025_2026
		   an19=an2026_2027
		   an20=an2027_2028
 		   an21=an2028_2029
		   an22=an2029_2030
		   an23=an2030_2031
		   an24=an2031_2032
		   an25=an2032_2033
		   an26=an2033_2034	
		   an27=an2034_2035	
		   an28=an2035_2036	
		   an29=an2036_2037
		   an30=an2037_2038; 
	 
run;

PROC EXPORT DATA=export_jp_Autres2
			OUTFILE="&nom"
            DBMS=excel
			REPLACE;
            SHEET="TempDistAutres";			
RUN;


/***********************************************************************************/
/******                 Tableaux  exporter en Excel (fin)                     *****/
/***********************************************************************************/


